;****************************************************************************************
;*                           LAUFLICHT ODER LICHTERKETTE VON DL3UKH                     *
;*                           ======================================                     *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;*                                                                                      *
;* ALS PIC-IC WURDE GENOMMEN PIC16F88                                                   *
;* ALS OSZILLATOR WURDE EIN INTERNER RC 4,00MHZ GENOMMEN. (T=0.25SEC ALSO DIE TAKTZEIT)*
;*                                   EIN BEFEHL HAT MEIST 4 TAKTE SIND 1,0SEC          *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;*                           BEGINN: 21.10.17                                           *
;*                           ENDE  :                                            *
;*                         GETESTET:                                            *
;****************************************************************************************

        LIST    P=16F88       
        TITLE   "LED-LICHT"

        ERRORLEVEL -302
        INCLUDE <P16F88.INC>

__CONFIG _CONFIG1, _CP_OFF & _CCPMX_RB0 & _DEBUG_OFF & _WRT_OFF & _CPD_OFF & _LVP_OFF & _BOREN_OFF & _MCLRE_OFF & _PWRTE_OFF & _WDTE_OFF & _INTRC_IO
__CONFIG _CONFIG2, _IESO_OFF & _FCMEN_OFF



;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG


HELP                    EQU     0X22        ;HILFSZELLE
NR                      EQU     0X23        ;HILFSZELLE
VERG_NR                 EQU     0X24        ;VERGLEICH MODUS
NRR                     EQU     0X25        ;HILFSZELLE

AD_H                    EQU     0X26        ;AD-MESSUNG
AD_L                    EQU     0X27        ;AD-MESSUNG

;--------------------------- VARIABLEN -------------------------------------
BIT7                    EQU     7       ; BIT 7
BIT6                    EQU     6       ; BIT 6
BIT5                    EQU     5       ; BIT 5
BIT4                    EQU     4       ; BIT 4
BIT3                    EQU     3       ; BIT 3 
BIT2                    EQU     2       ; BIT 2
BIT1                    EQU     1       ; BIT 1 
BIT0                    EQU     0       ; BIT 0
;--------------------------------------------------------------------------

;------------------------- MACROS -----------------------------------------

BANK0           MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                BCF     STATUS,RP0
                BCF     STATUS,RP1
                ENDM

BANK1           MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                BSF     STATUS,RP0
                BCF     STATUS,RP1
                ENDM

BANK2           MACRO                   ;MACRO TO SELECT DATA RAM BANK 2
                BCF     STATUS,RP0
                BSF     STATUS,RP1
                ENDM

BANK3           MACRO                   ;MACRO TO SELECT DATA RAM BANK 3
                BSF     STATUS,RP0
                BSF     STATUS,RP1
                ENDM

;----------------------------------------------------------------------------
;-----------------------------------------------------------------------------

;SPEICHERANFANG BZW. BEGINN

                ORG 0X0000
                GOTO MAIN               ; SPRUNG ZUM HAUPTPROGRAMM
                ORG 0X0004
                RETFIE 

                ORG 0X0010

;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*                              20.10.17                                     *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN            CLRF    PORTA                           
                CLRF    PORTB

                BANK1
                MOVLW   B'01101110'             ;0110-4MHZ INTERN-RC / 1-VOM SYSTEM / 1-STABILE FREQUENZ / 1-RC-TAKT-INTERN FUER SYSTEM
                MOVWF   OSCCON

                MOVLW   0X07                    ;COMPARATORS ALLE AUS VOM PORT A
                MOVWF   CMCON

                MOVLW   B'00111100'             ;INIT INPUT/OUTPUT AM PORTA FAST ALLES EINGANG / BEI 1 EINGANG  / RA6+RA7+RA0+RA1 HIER ALS AUSGANG BEI 0 AUSGANG
                MOVWF   TRISA
                MOVLW   B'00000000'             ;INIT I/O PORTB  ALLES AUSGANG 
                MOVWF   TRISB

;INIT TIMER 0 FUER 1MSEC
                MOVLW   B'10000100'             ;BIT0-2 1=PRESCALER32, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                MOVWF   OPTION_REG

;AD-INIT
                MOVLW   B'00010000'  ;RA4 ALS AD4/AN4
                MOVWF   ANSEL
;AD-INIT
                MOVLW   B'10000000'  ;RECHTSBNDIG B1 / FOSZ=32 B0 / VSS+VDD REF-SPANNUNG B00
                MOVWF   ADCON1
                BANK0
;AD-INIT
                MOVLW   B'11100001'  ;FOSZ=RC B11 / AD4 B100 / GO-IST AUS + ON IST EIN B001
                MOVWF   ADCON0

                CALL    LOE     ;LEDS LSCHEN LEUCHTEN NICHT

;20MSEC ZEITSCHLEIFE
                MOVLW   D'40'                   ;ZEITSCHLEIFE LADEN IN W MIT DEZIMAL 100 ALSO---> 100*1MSEC=100MSEC
                CALL    ZS0_5MSEC               ;ZEITSCHLEIFE ABARBEITEN
;---------------------------------------------------------------------------------------------------------------------

;GEHT LOS
ANF             MOVF    PORTA, W
                ANDLW   B'00100000'
                MOVWF   NRR

                MOVLW   B'00100000'
                SUBWF   NRR, W
                BTFSS   STATUS, Z
                GOTO    ANDERE_SCHALTER

                MOVF    PORTA, W
                ANDLW   B'00001100'
                MOVWF   NR

                BCF     STATUS, C
                RRF     NR, F

                BCF     STATUS, C
                RRF     NR, F

                MOVLW    0X00
                SUBWF    NR, W
                BTFSC    STATUS, Z
                GOTO     TEIL01

                MOVLW    0X01
                SUBWF    NR, W
                BTFSC    STATUS, Z
                GOTO     TEIL02

                MOVLW    0X02
                SUBWF    NR, W
                BTFSC    STATUS, Z
                GOTO     TEIL03

                MOVLW    0X03
                SUBWF    NR, W
                BTFSC    STATUS, Z
                GOTO     TEIL04

                GOTO     ANF
;;;;;;;;;;;;

ANDERE_SCHALTER MOVF    PORTA, W
                ANDLW   B'00001100'
                MOVWF   NR

                BCF     STATUS, C
                RRF     NR, F

                BCF     STATUS, C
                RRF     NR, F

                MOVLW    0X00
                SUBWF    NR, W
                BTFSC    STATUS, Z
                GOTO     TEIL05

                MOVLW    0X01
                SUBWF    NR, W
                BTFSC    STATUS, Z
                GOTO     TEIL06

                MOVLW    0X02
                SUBWF    NR, W
                BTFSC    STATUS, Z
                GOTO     TEIL07

                MOVLW    0X03
                SUBWF    NR, W
                BTFSC    STATUS, Z
                GOTO     TEIL08

                GOTO     ANF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TEIL01          CALL    LOE     ;LEDS LSCHEN LEUCHTEN NICHT
                CALL    AD_ZS

                BSF     PORTB, BIT0 
                CALL    AD_ZS
                BSF     PORTB, BIT1 
                CALL    AD_ZS
                BSF     PORTB, BIT2 
                CALL    AD_ZS
                BSF     PORTB, BIT3 
                CALL    AD_ZS
                BSF     PORTB, BIT4 
                CALL    AD_ZS
                BSF     PORTB, BIT5 
                CALL    AD_ZS
                BSF     PORTB, BIT6 
                CALL    AD_ZS
                BSF     PORTB, BIT7 
                CALL    AD_ZS
;
                BSF     PORTA, BIT6 
                CALL    AD_ZS
                BSF     PORTA, BIT7 
                CALL    AD_ZS
                BSF     PORTA, BIT0 
                CALL    AD_ZS
                BSF     PORTA, BIT1 
                CALL    AD_ZS

                GOTO    ANF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TEIL02          CALL    LOE     ;LEDS LSCHEN LEUCHTEN NICHT
                CALL    AD_ZS

TEIL02A         BSF     PORTB, BIT0 
                CALL    AD_ZS
                BSF     PORTB, BIT1 
                CALL    AD_ZS
                BSF     PORTB, BIT2 
                CALL    AD_ZS
                BSF     PORTB, BIT3 
                CALL    AD_ZS
                BSF     PORTB, BIT4 
                CALL    AD_ZS
                BSF     PORTB, BIT5 
                CALL    AD_ZS
                BSF     PORTB, BIT6 
                CALL    AD_ZS
                BSF     PORTB, BIT7 
                CALL    AD_ZS
;
                BSF     PORTA, BIT6 
                CALL    AD_ZS
                BSF     PORTA, BIT7 
                CALL    AD_ZS
                BSF     PORTA, BIT0 
                CALL    AD_ZS
                BSF     PORTA, BIT1 
                CALL    AD_ZS

;
                BCF     PORTA, BIT1 
                CALL    AD_ZS
                BCF     PORTA, BIT0 
                CALL    AD_ZS
                BCF     PORTA, BIT7 
                CALL    AD_ZS
                BCF     PORTA, BIT6 
                CALL    AD_ZS

                BCF     PORTB, BIT7
                CALL    AD_ZS
                BCF     PORTB, BIT6 
                CALL    AD_ZS
                BCF     PORTB, BIT5 
                CALL    AD_ZS
                BCF     PORTB, BIT4 
                CALL    AD_ZS
                BCF     PORTB, BIT3 
                CALL    AD_ZS
                BCF     PORTB, BIT2 
                CALL    AD_ZS
                BCF     PORTB, BIT1 
                CALL    AD_ZS
                BCF     PORTB, BIT0 
                CALL    AD_ZS


                GOTO    ANF


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TEIL03          CALL    LOE     ;LEDS LSCHEN LEUCHTEN NICHT
                CALL    AD_ZS

                BSF     PORTB, BIT0 
                BSF     PORTA, BIT1 
                CALL    AD_ZS
                BSF     PORTB, BIT1 
                BSF     PORTA, BIT0 
                CALL    AD_ZS
                BSF     PORTB, BIT2 
                BSF     PORTA, BIT7 
                CALL    AD_ZS
                BSF     PORTB, BIT3 
                BSF     PORTA, BIT6 
                CALL    AD_ZS
;
                BSF     PORTB, BIT4 
                BSF     PORTB, BIT7 
                CALL    AD_ZS
                BSF     PORTB, BIT5 
                BSF     PORTB, BIT6 
                CALL    AD_ZS

                GOTO    ANF


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TEIL04          CALL    LOE     ;LEDS LSCHEN LEUCHTEN NICHT
                CALL    AD_ZS


                BSF     PORTB, BIT0 
                BSF     PORTA, BIT1 
                CALL    AD_ZS
                BSF     PORTB, BIT1 
                BSF     PORTA, BIT0 
                CALL    AD_ZS
                BSF     PORTB, BIT2 
                BSF     PORTA, BIT7 
                CALL    AD_ZS
                BSF     PORTB, BIT3 
                BSF     PORTA, BIT6 
                CALL    AD_ZS
;
                BSF     PORTB, BIT4 
                BSF     PORTB, BIT7 
                CALL    AD_ZS
                BSF     PORTB, BIT5 
                BSF     PORTB, BIT6 
                CALL    AD_ZS

;;


                BCF     PORTB, BIT5 
                BCF     PORTB, BIT6 
                CALL    AD_ZS
                BCF     PORTB, BIT4 
                BCF     PORTB, BIT7 
                CALL    AD_ZS
                BCF     PORTB, BIT3 
                BCF     PORTA, BIT6 
                CALL    AD_ZS
                BCF     PORTB, BIT2 
                BCF     PORTA, BIT7 
                CALL    AD_ZS
;
                BCF     PORTB, BIT1 
                BCF     PORTA, BIT0 
                CALL    AD_ZS
                BCF     PORTB, BIT0 
                BCF     PORTA, BIT1 
                CALL    AD_ZS

                GOTO    ANF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TEIL05          CALL    LOE     ;LEDS LSCHEN LEUCHTEN NICHT
                CALL    AD_ZS


                BSF     PORTB, BIT0 
                CALL    AD_ZS
                BCF     PORTB, BIT0
                BSF     PORTB, BIT1 
                CALL    AD_ZS
                BCF     PORTB, BIT1
                BSF     PORTB, BIT2 
                CALL    AD_ZS
                BCF     PORTB, BIT2
                BSF     PORTB, BIT3
                CALL    AD_ZS
                BCF     PORTB, BIT3
                BSF     PORTB, BIT4 
                CALL    AD_ZS
                BCF     PORTB, BIT4
                BSF     PORTB, BIT5 
                CALL    AD_ZS
                BCF     PORTB, BIT5
                BSF     PORTB, BIT6 
                CALL    AD_ZS
                BCF     PORTB, BIT6
                BSF     PORTB, BIT7 
                CALL    AD_ZS
                BCF     PORTB, BIT7
                BSF     PORTA, BIT6 
                CALL    AD_ZS
                BCF     PORTA, BIT6
                BSF     PORTA, BIT7 
                CALL    AD_ZS
                BCF     PORTA, BIT7
                BSF     PORTA, BIT0 
                CALL    AD_ZS
                BCF     PORTA, BIT0
                BSF     PORTA, BIT1 
                CALL    AD_ZS

                GOTO    ANF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TEIL06          CALL    LOE     ;LEDS LSCHEN LEUCHTEN NICHT
                CALL    AD_ZS


                BSF     PORTB, BIT0 
                CALL    AD_ZS
                BCF     PORTB, BIT0
                BSF     PORTB, BIT1 
                CALL    AD_ZS
                BCF     PORTB, BIT1
                BSF     PORTB, BIT2 
                CALL    AD_ZS
                BCF     PORTB, BIT2
                BSF     PORTB, BIT3
                CALL    AD_ZS
                BCF     PORTB, BIT3
                BSF     PORTB, BIT4 
                CALL    AD_ZS
                BCF     PORTB, BIT4
                BSF     PORTB, BIT5 
                CALL    AD_ZS
                BCF     PORTB, BIT5
                BSF     PORTB, BIT6 
                CALL    AD_ZS
                BCF     PORTB, BIT6
                BSF     PORTB, BIT7 
                CALL    AD_ZS
                BCF     PORTB, BIT7
                BSF     PORTA, BIT6 
                CALL    AD_ZS
                BCF     PORTA, BIT6
                BSF     PORTA, BIT7 
                CALL    AD_ZS
                BCF     PORTA, BIT7
                BSF     PORTA, BIT0 
                CALL    AD_ZS
                BCF     PORTA, BIT0
                BSF     PORTA, BIT1 
                CALL    AD_ZS
;;;;
                BCF     PORTA, BIT1
                BSF     PORTA, BIT0 
                CALL    AD_ZS
                BCF     PORTA, BIT0
                BSF     PORTA, BIT7 
                CALL    AD_ZS
                BCF     PORTA, BIT7
                BSF     PORTA, BIT6 
                CALL    AD_ZS
                BCF     PORTA, BIT6
                BSF     PORTB, BIT7 
                CALL    AD_ZS
                BCF     PORTB, BIT7
                BSF     PORTB, BIT6 
                CALL    AD_ZS
                BCF     PORTB, BIT6
                BSF     PORTB, BIT5 
                CALL    AD_ZS
                BCF     PORTB, BIT5
                BSF     PORTB, BIT4 
                CALL    AD_ZS
                BCF     PORTB, BIT4
                BSF     PORTB, BIT3 
                CALL    AD_ZS
                BCF     PORTB, BIT3
                BSF     PORTB, BIT2 
                CALL    AD_ZS
                BCF     PORTB, BIT2
                BSF     PORTB, BIT1 
                CALL    AD_ZS
                BCF     PORTB, BIT1
                BSF     PORTB, BIT0 
                CALL    AD_ZS

                GOTO    ANF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TEIL07          CALL    LOE     ;LEDS LSCHEN LEUCHTEN NICHT
                CALL    AD_ZS


                BSF     PORTB, BIT0 
                CALL    AD_ZS
                BSF     PORTB, BIT1 
                CALL    AD_ZS
                BSF     PORTB, BIT2 
                CALL    AD_ZS
                BCF     PORTB, BIT0 
                BSF     PORTB, BIT3 
                CALL    AD_ZS
                BCF     PORTB, BIT1 
                BSF     PORTB, BIT4 
                CALL    AD_ZS
                BCF     PORTB, BIT2 
                BSF     PORTB, BIT5 
                CALL    AD_ZS
                BCF     PORTB, BIT3 
                BSF     PORTB, BIT6 
                CALL    AD_ZS
                BCF     PORTB, BIT4 
                BSF     PORTB, BIT7 
                CALL    AD_ZS
                BCF     PORTB, BIT5 
                BSF     PORTA, BIT6 
                CALL    AD_ZS
                BCF     PORTB, BIT6 
                BSF     PORTA, BIT7 
                CALL    AD_ZS
                BCF     PORTB, BIT7 
                BSF     PORTA, BIT0 
                CALL    AD_ZS
                BCF     PORTA, BIT6 
                BSF     PORTA, BIT1 
                CALL    AD_ZS
                BCF     PORTA, BIT7 
                CALL    AD_ZS
                BCF     PORTA, BIT0 
                CALL    AD_ZS
                BCF     PORTA, BIT1 
                CALL    AD_ZS

                GOTO    ANF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TEIL08          CALL    LOE     ;LEDS LSCHEN LEUCHTEN NICHT
                CALL    AD_ZS



                BSF     PORTB, BIT0 
                CALL    AD_ZS
                BSF     PORTB, BIT1 
                CALL    AD_ZS
                BSF     PORTB, BIT2 
                CALL    AD_ZS
                BCF     PORTB, BIT0 
                BSF     PORTB, BIT3 
                CALL    AD_ZS
                BCF     PORTB, BIT1 
                BSF     PORTB, BIT4 
                CALL    AD_ZS
                BCF     PORTB, BIT2 
                BSF     PORTB, BIT5 
                CALL    AD_ZS
                BCF     PORTB, BIT3 
                BSF     PORTB, BIT6 
                CALL    AD_ZS
                BCF     PORTB, BIT4 
                BSF     PORTB, BIT7 
                CALL    AD_ZS
                BCF     PORTB, BIT5 
                BSF     PORTA, BIT6 
                CALL    AD_ZS
                BCF     PORTB, BIT6 
                BSF     PORTA, BIT7 
                CALL    AD_ZS
                BCF     PORTB, BIT7 
                BSF     PORTA, BIT0 
                CALL    AD_ZS
                BCF     PORTA, BIT6 
                BSF     PORTA, BIT1 
                CALL    AD_ZS
                BCF     PORTA, BIT7 
                CALL    AD_ZS
                BCF     PORTA, BIT0 
                CALL    AD_ZS
                BCF     PORTA, BIT1 
                CALL    AD_ZS

;;;
                BSF     PORTA, BIT1 
                CALL    AD_ZS
                BSF     PORTA, BIT0 
                CALL    AD_ZS
                BSF     PORTA, BIT7 
                CALL    AD_ZS
                BCF     PORTA, BIT1 
                BSF     PORTA, BIT6 
                CALL    AD_ZS
                BCF     PORTA, BIT0 
                BSF     PORTB, BIT7 
                CALL    AD_ZS
                BCF     PORTA, BIT7 
                BSF     PORTB, BIT6 
                CALL    AD_ZS
                BCF     PORTA, BIT6 
                BSF     PORTB, BIT5 
                CALL    AD_ZS
                BCF     PORTB, BIT7 
                BSF     PORTB, BIT4 
                CALL    AD_ZS
                BCF     PORTB, BIT6 
                BSF     PORTB, BIT3 
                CALL    AD_ZS
                BCF     PORTB, BIT5 
                BSF     PORTB, BIT2 
                CALL    AD_ZS
                BCF     PORTB, BIT4 
                BSF     PORTB, BIT1 
                CALL    AD_ZS
                BCF     PORTB, BIT3 
                BSF     PORTB, BIT0 
                CALL    AD_ZS
                BCF     PORTB, BIT2 
                CALL    AD_ZS
                BCF     PORTB, BIT1 
                CALL    AD_ZS
                BCF     PORTB, BIT0 
                CALL    AD_ZS


                GOTO    ANF


;*****************************************************************************
;*              AUSGAENGE LOESCHEN / LEDS NICHT LEUCHTEN                     *
;*****************************************************************************
LOE
                MOVLW   0X00
                MOVWF   PORTB
                MOVLW   0X00
                MOVWF   PORTA
                RETURN

;*****************************************************************************
;*                              ZEITSCHLEIFE+AD-MESSUNG                      *
;*****************************************************************************
AD_ZS
                BCF     PIR1, ADIF 
                BSF     ADCON0, GO_DONE  ;GEHT LOS DIE MESSUNG

AD1             BTFSS   PIR1, ADIF
                GOTO    AD1

                BCF     ADCON0, GO_DONE  ;STOP DER MESSUNG

;AD-ERGEBNIS ABSPEICHERN IN RAM-ZELLEN AD_H UND AD_L
                MOVF    ADRESH, W
                MOVWF   AD_H
                BANK1                               
                MOVF    ADRESL, W
                BANK0                               
                MOVWF   AD_L

;---------
;1024 ZU 256 DEZ. MACHEN
                BCF     STATUS, C
                RRF     AD_H, F         ;ZU 512MAX.
                RRF     AD_L, F

                BCF     STATUS, C
                RRF     AD_H, F         ;ZU 256MAX.
                RRF     AD_L, F

                MOVLW    0X00
                SUBWF    AD_L, W
                BTFSS    STATUS, Z
                GOTO     EEE

                INCF     AD_L, F      ;UM EINS ERHHEN ALSO 0X01 FR AD_L --->WENN NULL

EEE             MOVF     AD_L, W
                CALL     ZS0_5MSEC

;150MSEC : 256 = CA. 0,5MSEC
;LEUCHTET MAXIMAL 0,5SEC ALSO EIN ZYKLUS



;AUSWERTUNG VERGLEICH NUMMER ALSO NEUER ZYKLUS / SCHALTER VERNDERT
;DAMIT ES SOFORT REAGIERT / NICHT BIS EIN ZYKLUS ZU ENDE IST
                MOVF    PORTA, W
                ANDLW   B'00100000'
                ;MOVWF   VERG_NRR

                ;MOVF    VERG_NRR, W
                SUBWF   NRR, W
                BTFSS   STATUS, Z
                GOTO    MAIN

;;;;;;;;;;;;;;;;;;
                MOVF    PORTA, W
                ANDLW   B'00001100'
                MOVWF   VERG_NR

                BCF     STATUS, C
                RRF     VERG_NR, F

                BCF     STATUS, C
                RRF     VERG_NR, F

                MOVF     VERG_NR, W
                SUBWF    NR, W
                BTFSS    STATUS, Z
                GOTO     MAIN



;LEUCHTET JETZT MINIMAL CA. 30MSEC BIS MAX. 500MSEC/0,5SEC
                MOVLW   D'60'
                CALL    ZS0_5MSEC



                RETURN



;*****************************************************************************
;*                              0,5MSEC ZEITSCHLEIFE                         *
;*****************************************************************************
ZS0_5MSEC                 
                        MOVWF   HELP

ZS11                    MOVLW   D'241'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 225 GELADEN
                        BCF     INTCON, TMR0IF          ;OVERFLOW = 0
                
ZS12                    BTFSS   INTCON, TMR0IF          ;WENN DIE ZEIT VON 10MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
                        GOTO    ZS12                    ;ES ERFOLGT EIN SPRUNG ZU "DECFSC ZAE, F"..... VORHER ANDERES ABARBEITEN

                        DECFSZ  HELP, F                 ;ES WIRD DER WERT IN "HELP" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    ZS11                    ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS

                        RETURN

;ZEITBERECHNUNG FUER 1MS
;(HIER MUSS MAN IN DEM DATENBLATT (DATASHEET) BEI WWW.MICROCHIP.COM (EIN *.PDF-FILE) NACHSEHEN, WIE ALLES FUNKTIONIERT)

;PRESCALER 32X  *  SYSTEM 4X  * TAKTZEIT ====> 32*4*0.25S=32SEC /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;1MS : 32S= 31,25  GENOMMEN 31                                   /T = 1 : F  (F)-OSZILLATORFREQUENZ HIER 16MHZ
;ALSO 
;32S*D'31'=0,992MSEC
;TMR0 ALSO D'256'-D'31'=D'225' ENTSPRICHT CA. 1MSEC

;GENOMMEN HIER 0,5MSEC
;TMR0 ALSO D'256'-D'15'=D'241' ENTSPRICHT CA. 0,5MSEC
;241 DEZIMAL OBEN EINTRAGEN



            END





